
#import <Foundation/Foundation.h>

#define OBJECTS   500000


int main (int argc, const char *argv[])
{
   NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
   id		*array;
   unsigned int  i, j;
   NSHashTable   *table;
   NSMutableSet  *set;
   
   
   array = malloc( sizeof( id) * OBJECTS);
   for( i = 0; i < OBJECTS; i++)
      array[ i] = [[NSObject alloc] init];
#if 0   
   for( i = 0; i < OBJECTS; i++)
      printf( "%lx\n", array[ i]);
#endif
   
   table = NSCreateHashTable( NSNonRetainedObjectHashCallBacks , OBJECTS);
   NSLog( @"Start NSHashTable %ld Objects", OBJECTS);
   for( i = 0; i < OBJECTS; i++)
      NSHashInsertKnownAbsent( table, array[ i]);
   NSLog( @"Done");

   set = [NSMutableSet set];
   NSLog( @"Start NSSet %ld Objects", OBJECTS);
   for( i = 0; i < OBJECTS; i++)
      [set addObject:array[ i]];
   NSLog( @"Done");

   [pool release];
   exit(0);       // insure the process exit status is 0
   return 0;      // ...and make main fit the ANSI spec.
}
